(function ($) {
    "use strict";

    $(document).ready(() => {
        
        $('.btn-worthstock').click(function (e) {
            //alert(this);
            e.preventDefault();
            
            if ( !confirm('Vuoi continuare?') ) return false;
            //let caller = e.target.id;
            let caller = $(this).attr('id');
            let caller_action = get_caller_action(caller);

            load_data(caller_action);
        });

        $('a#ws-real-prodotto-check').click(function (e) {
            e.preventDefault();
            if ( !confirm('Vuoi continuare?') ) return false;
            let caller_action = 'get_all_products_published';
            load_data(caller_action);
        });
        

        $('#worthstock_test_environment_flag').change(function() {      
            if (this.value === 'yes') {
                $('#api_login').parents('tr').hide();
                $('#api_secret').parents('tr').hide();
                $('#api_test_login').parents('tr').show();
                $('#api_test_secret').parents('tr').show();
            } else if (this.value === 'no') {
                $('#api_login').parents('tr').show();
                $('#api_secret').parents('tr').show();
                $('#api_test_login').parents('tr').hide();
                $('#api_test_secret').parents('tr').hide();
            }
        }).trigger('change');

        
        function get_caller_action(caller) {
            let caller_action = null;
            
            switch(caller) {
                case 'worthstock-button-login':
                    caller_action = 'api_login';
                    break;

                case 'worthstock-button-single-product':
                    caller_action = 'get_single_product';
                    break;
                    
                case 'worthstock-button-all-products':
                    caller_action = 'get_all_products';
                    break;
                    
                case 'worthstock-button-get-categories':
                    caller_action = 'get_categories';
                    break;

                case 'worthstock-button-erase-metadata':
                    caller_action = 'erase_plugin_metadata';
                    break;

                default:
                    break;
            }
            return caller_action;
        }

        function load_data(caller) {
       
            let action = 'api_actions';
            let message_div = $('#worthstock-button-messages');
            let sample_div = $('#worthstock-button-sample');
            let loader = $('#worthstock-button-loader');
            let buttons = $('.btn-worthstock');
            let sample = '';
            
            var data = {
                'action': action,
                'caller': caller,
                _nonce: worthstock_params.nonce
            };

            if (caller == 'get_all_products_published') {
                let id_product = [3642];
                data.id_product = id_product;
            }
    
            $.post({ // you can also use $.post here
                url: worthstock_params.ajaxurl, // AJAX handler
                data: data,
                dataType: 'json',
                beforeSend: function (xhr) {
                    loader.show();
                    message_div.text('Esecuzione '+ caller +' ...');
                    buttons.toggleClass('disabled');
                },
                success: function (data) {
                    
                    if (data) {
                        console.log(data);
                        if (data.success == true) {
                            let return_message = (data.data.message ? ' ' + data.data.message : 'Esecuzione terminata');
                            sample = (data.data.sample_data ? data.data.sample_data : null);

                            message_div.text(return_message);
                            // if (sample) {
                            //     if (typeof val !== "string") {
                            //         sample = JSON.stringify(sample);
                            //     }
                            //     sample_div.text(sample);
                            // }

                        } else {
                            let return_message = 'C\'è stato un errore';
                            if (data.data.message == 'invalid_nonce') {
                                return_message = 'Sessione scaduta, si prega di ricaricare la pagina e riprovare.';
                            }
                            message_div.text(return_message);
                        }
                            
                    } else {
                        //button.remove(); // if no data, remove the button as well
                        message_div.text('No news is good news');
                    }
                    loader.hide();
                    buttons.toggleClass('disabled');
                }
    
            });
        }
    });


})(jQuery);

